import arjuna.JavaSim.Simulation.*;
import arjuna.JavaSim.Distributions.*;

import java.io.IOException;
import java.lang.*;
import arjuna.JavaSim.Simulation.SimulationException;

public class Arrivals extends SimulationProcess {
     
    public Arrivals (double mean,int seed ) {
	
	InterArrivalTime = new ExponentialStream(mean,seed);
	    NodoInicial = new UniformStream(0.0,10.0,seed);
	    Recorrido = new ExponentialStream(MachineShop.NHOSTS/2.0,seed);
    }
    
    public void run () {
	
	for (;;) {
	    
	    try {		
		int recorri,nodoIni,nodoFin;
		double d;
		d=InterArrivalTime.getNumber();
		
		Hold(d);
		
		d=NodoInicial.getNumber();
		nodoIni= (int) Math.floor(d);

		do {
		    d=Recorrido.getNumber();
		    recorri= (int) Math.rint(d); //tambien puedo usar rint
		    // floor o rint redondea
		    nodoFin= (nodoIni+recorri) % MachineShop.NHOSTS;
		} while (recorri<1 || (nodoIni==nodoFin));
				
		Job work = new Job(nodoIni,nodoFin);
		MachineShop.Hosts[nodoIni].Request(work);
	    }
	    
	    catch (SimulationException e) {}
	    catch (RestartException e) {}
	    catch (IOException e) {}
	}
    }
   
    private ExponentialStream InterArrivalTime;
   
   private UniformStream NodoInicial; 
   // da un n entre 0 y 10 para la estacion inicial    
   //private UniformStream Recorrido;
   
  private ExponentialStream Recorrido;
   // dara un n con media n/2
};







