import arjuna.JavaSim.Simulation.*;
import arjuna.JavaSim.Distributions.*;

import java.io.IOException;
import arjuna.JavaSim.Simulation.SimulationException;

public class Machine extends SimulationProcess {
    
    public Machine (double service_time, int id){
	serviceTime=service_time;
	working = false;
	J = null;
	idHost=id;
	Q=new Queue();
	processedJobs=0;
    }
    
    public void run () {
	for (;;) {

	    working = true;
	    
	    while (!Q.IsEmpty()) {
		
		try {		
		    //J = Q.Dequeue(); //  sale de la cola 		    
		    Hold(serviceTime); // esta en el servidor sirviendose
		    J = Q.Dequeue();
		    processedJobs++; 
		}
		
		catch (SimulationException e) {}
		catch (RestartException e) {}
		
		if (J.HostFinal()!= HostNum()) 
		    // Al menos debe recorrer uno
		    // Si nodoIni=9 y nodoFin=9 entra en el else 
		    // y solo pasa por un nodo.
		    // Controlar esto en Arrival.java, que no se genere este 
		    // caso.
		    MachineShop.Hosts[( (HostNum()+1) % MachineShop.NHOSTS)].Request(J);
		else 
		 
		 
		 /*
		  * Introduce this new method because we usually rely upon
		  * the destructor of the object to do the work in C++.
		  */
		 
		 J.finished();
	       
	    }
	   
	   working = false;
	   
	   try {
	       Cancel();
	   }
	   catch (RestartException e) {}	   	  
	}
    }
    
    
    public void Request (Job trabajo) { 
	// no la retransmiten throws SimulationException, RestartException {
      	
	Q.Enqueue(trabajo);
	if (! working) {
	    try {
		Activate();
	    }
	    catch (SimulationException e) {}
	    catch (RestartException e) {}	    
	}      
    }
    
    public long QueueSize() {
	return Q.QueueSize();
    }
    public long ProcessedJobs() {
	return processedJobs;
    }
    public boolean Processing () {
	return working;
    }
    public int HostNum () {
	return idHost;
    }

    private long processedJobs;
    private Queue Q;    
    private boolean working;
    private Job J;
    private double serviceTime;
    private int idHost;
   
};
