import arjuna.JavaSim.Simulation.*;
import arjuna.JavaSim.Distributions.*;

import java.io.IOException;
import java.lang.*;
import arjuna.JavaSim.Simulation.SimulationException;

public class Arrivals extends SimulationProcess {
    
    public Arrivals (double mean,int seed ) {
	
	InterArrivalTime = new ExponentialStream(mean,seed);

	// la uniforme da un n entre 0 y 9, para la estacion inicial y final
	// pues luego uso la funcin floor que redondea al menor, el 10
	// nunca saldra como nodo inicial.
	NodoInicial = new UniformStream(0.0,10.0,seed); 
	NodoFinal = new UniformStream(0.0,10.0,seed);
    }

    
    public void run () {
	for (;;) {
	    try {		
		int nodoIni,nodoFin;
		double d;
		d=InterArrivalTime.getNumber();
		Hold(d);
		
		d=NodoInicial.getNumber();
		//System.out.println("nodoInicial="+d); // para la prueba
		nodoIni= (int) Math.floor(d);

		do {
		    d=NodoFinal.getNumber();
		    nodoFin= (int) Math.floor(d);
		} while (nodoIni==nodoFin);

	       Job work = new Job(nodoIni,nodoFin);
	       MachineShop.Hosts[nodoIni].Request(work);
	    }	    
	    catch (SimulationException e) {}
	    catch (RestartException e) {}
	    catch (IOException e) {}	       
	}
    }
   
    private ExponentialStream InterArrivalTime;   
    private UniformStream NodoInicial; 
    private UniformStream NodoFinal;
};
