import arjuna.JavaSim.Simulation.*;
import arjuna.JavaSim.Distributions.*;

import java.io.IOException;
import arjuna.JavaSim.Simulation.SimulationException;

public class Machine extends SimulationProcess {
    
    public Machine (double service_time, int id) {
	serviceTime=service_time;
	working = false;
	J = null;
	idHost=id;
	Q=new Queue();
	processedJobs=0;
    }
    
    public void run () {
	for (;;) {
	    working = true;
	    
	    while (!Q.IsEmpty()) {
		
		try {
		    // J = Q.Dequeue(); //  sale de la cola
		    // debe ser asi, pero para comparar con c++ estaba del
		    // otro modo.		  
		   
		   Hold(serviceTime); // esta en el servidor sirviendose
		   J = Q.Dequeue(); //  sale de la cola
		   processedJobs++;
		
		   if (J.HostInicial()== HostNum()) {
		       // pasa del nodo inicial a la estrella
		       MachineShop.Hosts[MachineShop.SWITCH].Request(J);
		   }
		   else {
		       if (HostNum()== MachineShop.SWITCH) {
			   // estoy en el nodo estrella
			   MachineShop.Hosts[J.HostFinal()].Request(J);
		       }
		       else {
			   /*
			    * Introduce this new method because we usually rely upon
			    * the destructor of the object to do the work in C++.
			    */
			   
			   J.finished();
		       }
		   }
		    
		}
		
		catch (SimulationException e){}
		catch (RestartException e) {}
		
	    } //end while
	    
	    working = false;
	    
	    try {
		
		Cancel();
	    }
	    catch (RestartException e) {}
	}
	
    }
    public void Request (Job trabajo)  {
      	
	Q.Enqueue(trabajo);
	if (! working) {
	    try {
		Activate();
	    }
	    catch (SimulationException e) {}
	    catch (RestartException e) {}    
	}      
    }
    
    public long QueueSize() {
	return Q.QueueSize();
    }
    public long ProcessedJobs() {
	return processedJobs;
    }
    public boolean Processing () {
	return working;
    }
    public int HostNum () {
	return idHost;
    }
    
    private long processedJobs;
    private Queue Q;    
    private boolean working;
    private Job J;
    private double serviceTime;
    private int idHost;
    
};
