import java.lang.*;
import arjuna.JavaSim.Simulation.*;
import arjuna.JavaSim.Statistics.*;

import arjuna.JavaSim.Simulation.SimulationException;

public class MachineShop extends SimulationProcess {
    
    public MachineShop (double tLlegadas, int sem ) {
	tiempoLlegadas=tLlegadas;
	semilla=sem;
    }   
    
    public void run () {

	try {

	    Arrivals A = new Arrivals(tiempoLlegadas,semilla);

	    for (int id=0;id<NHOSTS;id++)
		// creo diez maquinas con el t de servicio e identinficador
		MachineShop.Hosts[id] = new Machine(SERVICETIME,id);
	    
	 A.Activate(); 
	 // Inicio el proceso que genera los paquetes de llegada
	 
	 Scheduler.startSimulation();
	 
	 while (ErasedJobs < FINALSIMULACION) {
	     Hold(1000);
	 }	 
	
	 Scheduler.stopSimulation();
	 
	 A.terminate();
	
	 int encolados=0;
	 for (int id=0;id<NHOSTS;id++) {
	    // para diez maquinas con el t de servicio e identinficador
	     MachineShop.Hosts[id].terminate();
	     encolados+=MachineShop.Hosts[id].QueueSize();
	     System.out.println("Jobs processed by Host"+id+" "+MachineShop.Hosts[id].ProcessedJobs());
	 }
	 
	 System.out.println("Total number of jobs present "+TotalJobs);
	 System.out.println("Total number of jobs processed "+ErasedJobs);
	 System.out.println("Average time response="+meanDelay.mean());
	 // con el "=" hago que se corte en el shell los datos
	 System.out.println("Total queued jobs "+encolados);
	 long auxTotalJobs=encolados+ErasedJobs;
	 System.out.println("Queued jobs + erased jobs "+auxTotalJobs); 
	 
	 //modificado  SimulationProcess.mainResume();
	 // el cerrojo se hereda del paquete de simulacion
	 // se declara en la simulationProcess.java -> public Object cerrojo = new Object();
	 
         synchronized(cerrojo) { //modificado
	     cerrojo.notify(); // Hago que se despierte el Main
	 }
	 
	}
	catch (SimulationException e){}
	catch (RestartException e) {}
    }
    
    public void Await () {
	this.Resume();
	//modificado SimulationProcess.mainSuspend();
    }
    public static final int NHOSTS=11;
    public static final int SWITCH=NHOSTS-1;
    public static Machine [] Hosts =new Machine[NHOSTS];    
    public static long TotalJobs = 0;
    public static long ErasedJobs = 0;
    public static final int FINALSIMULACION=3000;
    public static double TotalResponseTime=0.0;
    public static final double SERVICETIME=1.0;
    public static double tiempoLlegadas;
    public static int semilla;
    public static final int TRANSITORIO=50;
    public static Mean meanDelay=new Mean();


};
