import java.lang.*;
import arjuna.JavaSim.Simulation.*;
import arjuna.JavaSim.Statistics.*;
import arjuna.JavaSim.Distributions.*;

public class Main {
    public static void main (String[] args) {

	for (int i = 0; i < args.length; i++) {
	    if (args[i].equalsIgnoreCase("-help")) {
		System.out.println("Usage: Main semilla tiempoLlegadas [-help]");
		System.exit(0);
	    }
	}
	if (args.length!=2) { // 2 es el numero de argumentos
	    // el java y Main no aparecen
	    System.out.println("Usage: Main semilla tiempoLlegadas [-help]");
	    System.exit(0);
	}	
	
	double tiempollegadas= Float.valueOf(args[1]).floatValue();
	int semilla= Integer.valueOf(args[0]).intValue();
	MachineShop m = new MachineShop(tiempollegadas,semilla);
	
	m.Await();
	
	synchronized(m.cerrojo) {
	    try {
		m.cerrojo.wait();
	    }
	    catch (InterruptedException e) {
		System.out.println(e.getMessage());
		System.exit(1);
	    }
	}
	
	System.exit(0);
    }
    
}
