package arjuna.JavaSim.Distributions;

import java.io.IOException;

/**
   Devuelve 'true' o 'false' con la probabilidad indicada en el constructor. 
   Internamente usa una distribucin uniforme (UniformStream).
  */

public class Draw {

    /**
       Crea un objeto para generar valores 'true' con la probabilidad
       indicada como parmetro.
      */
    
public Draw (double p)  {
	s = new UniformStream(0, 1);
	prob = p;
}

    /** 
	Crea un objeto para generar valores 'true' con la probabilidad
	indicada como parmetro. El segundo parmetro es la semilla de la
	simulacin.
    */
    
public Draw (double p, int StreamSelect)    {
	s = new UniformStream(0, 1, StreamSelect);
	prob = p;
}
    
    /** 
	Crea un objeto para generar valores 'true' con la probabilidad
	indicada como parmetro. El segundo parmetro es la semilla de la
	simulacin. Los parmetros tercero y cuarto sern las semillas del 
	generador lineal y congruencial de la clase abstracta 'RandomStream'.
    */
    
public Draw (double p, int StreamSelect, long MGSeed, long LCGSeed)     {
    s = new UniformStream(0, 1, StreamSelect, MGSeed, LCGSeed);
    prob = p;
}

    /**
       Devuelve 'true' con la probabilidad especificada en el constructor.
    */
    
public boolean getBoolean () throws IOException    {
	if (s.getNumber() >= prob)
	    return true;
	else
	    return false;
}
    
private UniformStream s;
private double prob;

};
