package arjuna.JavaSim.Distributions;

import java.lang.Math;
import java.io.IOException;
import java.lang.ArithmeticException;

/**
   Devuelve nmeros siguiendo una distribucin Exponencial 
   con la media que se le indique.
*/

public class ExponentialStream extends RandomStream {

    /**
       Crea un objeto que permitir generar valores con una distribucin 
       Exponencial cuya media se le indica como parmetro.
    */
    
public ExponentialStream (double m)    {
	super();

	Mean = m;
}

    /** 
	Crea un objeto que permitir generar valores con una distribucin 
	Exponencial cuya media se le indica como parmetro. El segundo 
	parmetro es la semilla de la simulacin.	
    */
    
public ExponentialStream (double m, int StreamSelect)    {
	super();

	Mean = m;

	for (int i = 0; i < StreamSelect*1000; i++)
	    Uniform();
}
    
    /**       
	Crea un objeto que permitir generar valores con una distribucin 
	Exponencial cuya media se le indica como parmetro.  El segundo 
	parmetro es la semilla de la simulacin. Los parmetros tercero y 
	cuarto sern las semillas del generador lineal y congruencial 
	de la clase abstracta 'RandomStream'.       
    */
    
public ExponentialStream (double m, int StreamSelect,
			  long MGSeed, long LCGSeed)    {
	super(MGSeed, LCGSeed);

	Mean = m;

	for (int i = 0; i < StreamSelect*1000; i++)
	    Uniform();
    }

    /**
       Devuelve valores siguiendo una distribucin Exponencial.
    */
    
public double getNumber () throws IOException, ArithmeticException
    {
	return -Mean*Math.log(Uniform());
    }

private double Mean;
    
};
