package arjuna.JavaSim.Distributions;

import java.io.IOException;
import java.lang.ArithmeticException;

/**
   Devuelve nmeros siguiendo una distribucin Uniforme
   entre el lmite inferior y el lmite superior que se le indique.
*/

public class UniformStream extends RandomStream {

    /**
       Crea un objeto que permitir generar valores con una distribucin
       Uniforme cuyo lmite inferior y lmite superior se le indican 
       como parmetros.
    */
    
public UniformStream (double l, double h)     {
	super();
	
	lo = l;
	hi = h;
	range = hi-lo;
}

    /** 
	Crea un objeto que permitir generar valores con una distribucin
	Uniforme cuyo lmite inferior y lmite superior se le indican como 
	parmetros.  El tercer parmetro es la semilla de la simulacin.
    */
    
public UniformStream (double l, double h, int StreamSelect)    {
	super();

	lo = l;
	hi = h;
	range = hi-lo;

	for (int i = 0; i < StreamSelect*1000; i++)
	    Uniform();
}

    /** 
	Crea un objeto que permitir generar valores con una distribucin
	Uniforme cuyo lmite inferior y lmite superior se le indican como 
	parmetros.  El tercer parmetro es la semilla de la simulacin.
	Los parmetros cuarto y quinto sern las semillas del generador lineal
	y congruencial de la clase abstracta 'RandomStream'.
    */
   
    
public UniformStream (double l, double h, int StreamSelect,
		      long MGSeed, long LCGSeed)    {
	super(MGSeed, LCGSeed);
	
	lo = l;
	hi = h;
	range = hi-lo;
	
	for (int i = 0; i < StreamSelect*1000; i++)
	    Uniform();
}
    
    /** 
	Devuelve valores siguiendo una distribucin Uniforme. 
    */
    
public double getNumber () throws IOException, ArithmeticException    {
	return lo+(range*Uniform());
}

private double lo;
private double hi;
private double range;

};
