package arjuna.JavaSim.Statistics;

import java.lang.*;
import java.io.*;


public class Bucket {

    /**
       Crea un cubo (?bucket) con el nombre del primer parmetro y el nmero 
       de entradas del segundo parmetro.
    */
    
public Bucket (double n, long initEntries)    {
	numberOfEntries = initEntries;
	name = n;
	next = null;
}

    /**
       Crea un cubo  (?bucket) con el nombre del parmetro y con una entrada.
    */
    
public Bucket (double n)    {
	numberOfEntries = 1;
	name = n;
	next = null;
}

    /**
       Constructor copia. Duplica fsicamente el objeto.
    */
    
public Bucket (Bucket b) {
    numberOfEntries = b.size();
    name = b.Name();
    next = null;
}

    /**
       Devuelve un booleano. Indica si el nombre del cubo (?bucket) es igual 
       que el parmetro.
    */
    
public boolean equals (double value)    {

	if (name == value)
	    return true;
	else
	    return false;
}

    /**
       Devuelve un booleano. Indica si el nombre del cubo (?bucket) es mayor 
       que el parmetro.
    */
    
public boolean greaterThan (double value)   {
	
	if (name > value)
	    return true;
	else
	    return false;
}
    
    /**
       Devuelve un booleano. Indica si el nombre del cubo (?bucket) es mayor 
       o igual que el parmetro.
    */
    
public boolean greaterThanOrEqual (double value)    {
	if (name >= value)
	    return true;
	else
	    return false;
    }

    /**
       Devuelve un booleano. Indica si el nombre del cubo (?bucket) es menor 
       que el parmetro.
    */
    
public boolean lessThan (double value)  {

	if (name < value)
	    return true;
	else
	    return false;
}

    /**
       Devuelve un booleano. Indica si el nombre del cubo (?bucket) es menor 
       o igual que el parmetro.
    */
    
public boolean lessThanOrEqual (double value)    {

	if (name <= value)
	    return true;
	else
	    return false;
}

    /**
       Devuelve el nombre del cubo (?bucket).
    */
    
public double Name ()    {

	return name;
}

    /**
       Incrementa el nmero de entradas que indica el parmetro.
    */
    
 public void incrementSize (long value)    {
	numberOfEntries += value;
 }

    /**
       Inicializa el nmero de entradas al valor que recibe como 
       parmetro.
    */
    
public void size (long value)    {
	numberOfEntries = value;
}

    /**
       Devuelve el nmero de entradas.
    */
    
public long size ()    {

        return numberOfEntries;
}

    /**
       Devuelve el siguiente cubo (?bucket).
    */
    
public Bucket cdr ()    {
	return next;
}

    /**
       Establece quin es el siguente cubo (?bucket).
    */
    
public void setCdr (Bucket n)    {
	next = n;
}
    
private long numberOfEntries;
private double name;
private Bucket next;
    
};
